<?php

$jscode[] = <<<EOC
var component_popup = false;

function component_callback(data)
{
    component_popup.contentDiv.innerHTML = data['info'] + data['screws'];
}

function component_popup_open(e, component)
{
    if (!component_popup) {
	var options = { hideOnClick: false, canDragFunc: true };

	component_popup = new Rico.Popup(options, false, false);
	component_popup.createWindow('<strong>Verwendung</strong>','','auto','280px');
    }

    var source = document.getElementById('source');
    if (!source) return false;

    var parms = 'source=' + source.innerHTML + '&callback=component&component=' + component;
    ajax_request('function', parms, component_callback);

    if (component_popup.divPopup.style.display == 'none')
	component_popup.openPopup(e.clientX-50, e.clientY-150);
}


function drill_second(e)
{
    if (e.originalTarget && e.originalTarget.target && e.originalTarget.target == '_top')
	return;

    var id = 0; // Column 0 contains ID
    var row = second.edit.drillDown(e,0,0);
    var cell = second.columns[id].cell(row);
    if (!cell) return;
    var value = cell.innerHTML;

    if (!value.length || value == '&nbsp;') return;

    component_popup_open(e, value);
};
EOC;

$style[] = <<<EOC
table.tinfo {
    font-size: 10px;
    color: #555;
}
EOC;

$mask = array(
	      'table' => 'hw_compound',
	      'title' => 'Liste der Verbindungen',
	      'rows' => 20,
	      'list' => array(
			      'id' => array(
					    'name' => 'ID',
					    'visible' => false,
					    ),
			      'name' => array(
					    'name' => 'Name',
					    'width' => 120,
					    ),
			      'hostname' => array(
					    'name' => 'Hostname',
					    'width' => 180,
					    ),
			      'ip' => array(
					    'name' => 'IP-Addr',
					    'width' => 80,
					    'visible' => false,
					    ),
			      'location' => array(
					    'name' => 'Location',
					    'specs' => "ClassName: 'aligncenter'",
					    'control' => "new Rico.TableColumn.lookup(".grid_lookup_sql('hw_organisation','id','name').", 0, '')",
					    'width' => 100,
					    ),
			      'status' => array(
					    'name' => 'Status',
					    'width' => 50,
					    'specs' => "filterUI: 's'",
					    'control' => "new Rico.TableColumn.lookup(".grid_lookup_sql('hw_status','id','name').", 0, '')",
					    ),
			      ),
	      'callbacks' => array(
				   'component' => cb_component,
				),
	      'second' => array(
			'title' => 'Komponenten',
			'table' => 'hw_screw',
			'join' => array(
					'hw_component ON component = hw_component.id',
					),
			'where' => 'compound = {id} AND hw_screw.endtime IS NULL ORDER BY name',
			'onclick' => 'drill_second',
			'list' => array(
			      'component' => array(
					    'name' => 'ID',
					    'visible' => false,
					    ),
			      'name' => array(
					    'name' => 'Komponente',
					    'width' => 180,
					    ),
			      'starttime' => array(
					    'name' => 'Seit',
					    'type' => 'date',
					    'width' => 80,
					    'sql' => 'hw_screw.starttime'
					    ),
			      'price' => array(
					    'name' => 'Preis',
					    'width' => 50,
					    'specs' => "decPlaces: 2, ClassName: 'alignrightpad', canSort: false",
					    ),
			      'usage' => array(
					    'name' => 'Verwendung',
					    'width' => 270,
					    ),
				   ),
				),
	      'edit' => array(
			      'name' => array(
					    'name' => 'Name',
					    'type' => 'text',
					    'size' => 25,
					    ),
			      'hostname' => array(
					    'name' => 'Hostname',
					    'type' => 'text',
					    'size' => 25,
					    ),
			      'ip' => array(
					    'name' => 'IP-Addresse',
					    'type' => 'text',
					    'size' => 16,
					    ),
			      'ident' => array(
					    'name' => 'Ident',
					    'type' => 'text',
					    'size' => 25,
					    ),
			      'location' => array(
					    'name' => 'Standort',
					    'type' => 'select',
					    'options' => 'SELECT id,name AS text FROM hw_organisation ORDER BY name',
					    ),
			      'status' => array(
					    'name' => 'Status',
					    'type' => 'select',
					    'options' => 'SELECT id,name AS text FROM hw_status ORDER BY id',
					    ),
			      'comment' => array(
					    'name' => 'Bemerkung',
					    'type' => 'textarea',
					    ),
			      ),
	      );

function cb_component()
{
  global $db;

  $data = array('info' => '', 'screws' => '');
  $sql = <<<EOC
SELECT hw_organisation.name AS owner,
    to_char(starttime,'DD.MM.YYYY') AS starttime,
    to_char(endtime,'DD.MM.YYYY') AS endtime,
    hw_component.comment,status,hw_status.name AS status
FROM hw_component
JOIN hw_organisation ON owner = hw_organisation.id
JOIN hw_status ON status = hw_status.id
WHERE hw_component.id = %d
EOC;
  $sql = sprintf($sql, $_POST['component']);
  $sth = $db->query($sql);

  $row = false;
  if ($sth !== false)
    $row = $sth->fetch();

  if ($row !== false) {
    $info = '<table border="0" cellpadding="0" class="tinfo">';
    $info .= sprintf('<tr><td>Eigentümer</td><td>:<td><td>%s</td></tr>', $row['owner']);
    $info .= sprintf('<tr><td>Von</td><td>:<td><td>%s</td></tr>', $row['starttime']);
    if (!empty($row['endtime']))
      $info .= sprintf('<tr><td>Bis</td><td>:<td><td>%s</td></tr>', $row['endtime']);
    if (!empty($row['comment']))
      $info .= sprintf('<tr><td valign="top">Bemerkung</td><td valign="top">:<td><td>%s</td></tr>', $row['comment']);
    $info .= sprintf('<tr><td>Status</td><td>:<td><td>%s</td></tr>', $row['status']);
    $info .= '</table>';
    $data['info'] = $info;
  }

  $sql = <<<EOC
SELECT hw_compound.name,
    to_char(hw_screw.starttime,'DD.MM.YYYY') AS starttime,
    to_char(hw_screw.endtime,'DD.MM.YYYY') AS endtime,
    usage
FROM hw_screw
JOIN hw_compound ON compound = hw_compound.id
WHERE component = %d ORDER BY hw_screw.starttime
EOC;
  $sql = sprintf($sql, $_POST['component']);
  $sth = $db->query($sql);

  $screws = '<table width="99%" border="0" cellspacing="0" class="tinfo">';
  $screws .= '<tr bgcolor="#b3ceff"><th>Name</th><th>Von</th><th>Bis</th><th>Verwendung</th></tr>';

  while ($row = $sth->fetch()) {
    $screws .= sprintf('<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>',
		       $row['name'], $row['starttime'], $row['endtime'], $row['usage']);

  }
  $screws .= '</table>';
  $data['screws'] = $screws;

  return $data;
}

?>
